-- Pour le bon fonctionnement de l'addon, merci de ne pas modifier le code
-- Sharas, le 26 septembre 2007 - http://worldofwarcraft.judgehype.com

local JHP_Stuff = {
  "HeadSlot",
  "NeckSlot",
  "ShoulderSlot",
  "ShirtSlot",
  "ChestSlot",
  "WaistSlot",
  "LegsSlot",
  "FeetSlot",
  "WristSlot",
  "HandsSlot",
  "Finger0Slot",
  "Finger1Slot",
  "Trinket0Slot",
  "Trinket1Slot",
  "BackSlot",
  "MainHandSlot",
  "SecondaryHandSlot",
  "RangedSlot",
  "TabardSlot",
};

local JHP_Rating = {
  "CR_WEAPON_SKILL",
  "CR_DEFENSE_SKILL",
  "CR_DODGE",
  "CR_PARRY",
  "CR_BLOCK",
  "CR_HIT_MELEE",
  "CR_HIT_RANGED",
  "CR_HIT_SPELL",
  "CR_CRIT_MELEE",
  "CR_CRIT_RANGED",
  "CR_CRIT_SPELL",
  "CR_HIT_TAKEN_MELEE",
  "CR_HIT_TAKEN_RANGED",
  "CR_HIT_TAKEN_SPELL",
  "CR_CRIT_TAKEN_MELEE",
  "CR_CRIT_TAKEN_RANGED",
  "CR_CRIT_TAKEN_SPELL",
  "CR_HASTE_MELEE",
  "CR_HASTE_RANGED",
  "CR_HASTE_SPELL",
  "CR_WEAPON_SKILL_MAINHAND",
  "CR_WEAPON_SKILL_OFFHAND",
  "CR_WEAPON_SKILL_RANGED",
};

function JHP_SaveProfil(numprofil)
	local ver = nil;
	if (GetLocale()=="frFR") then
		ver = "FR";
	elseif (GetLocale()=="enGB" or GetLocale()=="enUS") then
		ver = "EN";
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JudgeHype>|r Sauvegarde impossible, le Profiler ne supporte que les versions FR-EN-US.");
		return;
	end
	local Pname = JHC_CleanMe(UnitName("player"));
	if Pname == nil or Pname == "" or Pname == "Inconnu" or not GetCVar("realmName") then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JudgeHype>|r Sauvegarde impossible, probl\195\168me de syncronisation serveur.");
		return;
	end
	if UnitIsDeadOrGhost("player") then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JudgeHype>|r Sauvegarde impossible, vous \195\170tes mort.");
		return;
	end
	if UnitBuff("player", 1) or UnitDebuff("player",1) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JudgeHype>|r Sauvegarde impossible, veuillez enlever les sorts sur votre personnage.");
		return;
	end
	if UnitClass("player") == "Warrior" or UnitClass("player") == "Guerrier" then
		local _, _, Stanceactive = GetShapeshiftFormInfo(1);
		if (Stanceactive ~= 1) then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JudgeHype>|r Sauvegarde impossible, veuillez utiliser la posture de combat.");
			return;
		end
	end
	if UnitClass("player") == "Druid" or UnitClass("player") == "Druide" then
		local HasForm = nil;
		for i=1, GetNumShapeshiftForms(), 1 do
			local _, _, Stanceactive = GetShapeshiftFormInfo(i);
			if Stanceactive == 1 then
				HasForm = 1;
			end
		end
		if HasForm ~= nil then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JudgeHype>|r Sauvegarde impossible, veuillez quitter votre forme.");
			return;
		end
	end
	-- Create Arbo
	local Prealm = JHC_CleanMe(GetCVar("realmName"));
	local CurrentDate = date("%d/%m/%Y \195\160 %H:%M:%S");
	local Plist = Pname.."_"..Prealm.."_"..numprofil;
	if not JH_Profiler[Plist] then
		JH_Profiler[Plist] = {};
	end
	local profilreset = nil;
	if JH_Profiler[Plist] then
		if JH_Profiler[Plist].newprofil then
			profilreset = 1;
		end
	end
	if profilreset == nil then
		JH_Main.totprofils = JH_Main.totprofils+1;
	end
	JH_Profiler[Plist].newprofil = {};
	JH_Profiler[Plist].newprofil.pftrash = "|cffffffffProfil "..numprofil.."|r sauvegard\195\169 le "..date("|cffffffff%d/%m/%Y|r \195\160 |cffffffff%H:%M:%S|r");
	
	-- Profiler : General
	local Plevel = UnitLevel("player");
	local Prace = UnitRace("player");
	local Pclasse = UnitClass("player");
	local Pfaction = UnitFactionGroup("player");
	local Psex = UnitSex("player");
	local Pvie = UnitHealthMax("player");
	local Pmana = UnitManaMax("player");
	local PguildName, _, _ = GetGuildInfo("player");
	if PguildName then
		PguildName = JHC_CleanMe(PguildName);
	else
		PguildName = "NOGUILD";
	end
	JH_Profiler[Plist].newprofil.pf_infos = numprofil.."||"..GetLocale().."||"..GetBuildInfo().."||"..Pname.."||"..Prealm.."||"..CurrentDate.."||"..Plevel.."||"..Prace.."||"..Pclasse.."||"..Pfaction.."||"..Psex.."||"..PguildName.."||"..Pvie.."||"..Pmana;

	-- Profiler : Resistance
	local base, effectiveStat, _, _ = UnitResistance("player", 2);
	local PFire = base..":"..effectiveStat;
	local base, effectiveStat, _, _ = UnitResistance("player", 3);
	local PNature = base..":"..effectiveStat;
	local base, effectiveStat, _, _ = UnitResistance("player", 4);
	local PFrost = base..":"..effectiveStat;
	local base, effectiveStat, _, _ = UnitResistance("player", 5);
	local PShadow = base..":"..effectiveStat;
	local base, effectiveStat, _, _ = UnitResistance("player", 6);
	local PArcane = base..":"..effectiveStat;
	JH_Profiler[Plist].newprofil.pf_resists = PArcane.."||"..PFire.."||"..PNature.."||"..PFrost.."||"..PShadow;
	
	-- Profiler : Caracteristiques
	local _, effectiveStat, bonus, _ = UnitStat("player", 1);
	local Pforce = effectiveStat..":"..bonus;
	local _, effectiveStat, bonus, _ = UnitStat("player", 2);
	local Pagilite = effectiveStat..":"..bonus;
	local _, effectiveStat, bonus, _ = UnitStat("player", 3);
	local Pendurance = effectiveStat..":"..bonus;
	local _, effectiveStat, bonus, _ = UnitStat("player", 4);
	local Pintelligence = effectiveStat..":"..bonus;
	local _, effectiveStat, bonus, _ = UnitStat("player", 5);
	local Pesprit = effectiveStat..":"..bonus;
	local _, effectiveStat, _, bonus, _ = UnitArmor("player");
	local Parmor = effectiveStat..":"..bonus;
	local pourcentred = JHC_ArmorReduction();
	JH_Profiler[Plist].newprofil.pf_1 = Pforce.."||"..Pagilite.."||"..Pendurance.."||"..Pintelligence.."||"..Pesprit.."||"..Parmor.."||"..pourcentred;
	
	-- Profiler : Damages
	local meleecrit = format("%.2f",GetCritChance());
	local mainHandAttackBase, mainHandAttackMod, offHandAttackBase, offHandAttackMod = UnitAttackBothHands("player");
	local baseAP, posBuffAP, _ = UnitAttackPower("player");
	local speed, offhandSpeed = UnitAttackSpeed("player");
	local minDamage, maxDamage, minOffHandDamage, maxOffHandDamage, physicalBonusPos, physicalBonusNeg, percent = UnitDamage("player");
	local displayMin = max(floor(minDamage),1);
	local displayMax = max(ceil(maxDamage),1);
	minDamage = (minDamage / percent) - physicalBonusPos - physicalBonusNeg;
	maxDamage = (maxDamage / percent) - physicalBonusPos - physicalBonusNeg;
	local baseDamage = (minDamage + maxDamage) * 0.5;
	local fullDamage = (baseDamage + physicalBonusPos + physicalBonusNeg) * percent;
	local damagePerSecond = format("%.1f",(max(fullDamage,1) / speed));
	local displayMinOff = 0;
	local displayMaxOff = 0;
	local damagePerSecondOff = 0;
	if offhandSpeed then
		minOffHandDamage = (minOffHandDamage / percent) - physicalBonusPos - physicalBonusNeg;
		maxOffHandDamage = (maxOffHandDamage / percent) - physicalBonusPos - physicalBonusNeg;
		local offhandBaseDamage = (minOffHandDamage + maxOffHandDamage) * 0.5;
		local offhandFullDamage = (offhandBaseDamage + physicalBonusPos + physicalBonusNeg) * percent;
		displayMinOff = max(floor(minOffHandDamage),1);
		displayMaxOff = max(ceil(maxOffHandDamage),1);
		damagePerSecondOff = format("%.1f",(max(offhandFullDamage,1) / offhandSpeed));
	else
		offhandSpeed = 0;
	end
	local dmgresult;
	dmgresult = mainHandAttackBase..":"..mainHandAttackMod.."||"..offHandAttackBase..":"..offHandAttackMod;
	dmgresult = dmgresult.."||"..displayMin..":"..displayMax..":"..damagePerSecond.."||"..displayMinOff..":"..displayMaxOff..":"..damagePerSecondOff;
	dmgresult = dmgresult.."||"..format("%.2f",speed)..":"..format("%.2f",offhandSpeed);
	dmgresult = dmgresult.."||"..baseAP..":"..posBuffAP;
	dmgresult = dmgresult.."||"..meleecrit;
	JH_Profiler[Plist].newprofil.pf_2 = dmgresult;
	
	-- Profiler : Range Damages
	local rangecrit = format("%.2f",GetRangedCritChance());
	local rangedAttackBase, rangedAttackMod = UnitRangedAttack("player");
	local basePA, posBuffPA, _ = UnitRangedAttackPower("player");
	local rangedAttackSpeed, minDamage, maxDamage, physicalBonusPos, physicalBonusNeg, percent = UnitRangedDamage("player");
	local displayMin = max(floor(minDamage),1);
	local displayMax = max(ceil(maxDamage),1);
	local baseDamage;
	local fullDamage;
	local damagePerSecondRange;
	if PaperDollFrame.noRanged then
		damagePerSecondRange = "0.0";
	else
		if (HasWandEquipped()) then
			baseDamage = (minDamage + maxDamage) * 0.5;
			fullDamage = baseDamage * percent;
			damagePerSecondRange = (max(fullDamage,1) / rangedAttackSpeed);
			damagePerSecondRange = format("%.1f",damagePerSecondRange);
		else
			minDamage = (minDamage / percent) - physicalBonusPos - physicalBonusNeg;
			maxDamage = (maxDamage / percent) - physicalBonusPos - physicalBonusNeg;
			baseDamage = (minDamage + maxDamage) * 0.5;
			fullDamage = (baseDamage + physicalBonusPos + physicalBonusNeg) * percent;
			damagePerSecondRange = (max(fullDamage,1) / rangedAttackSpeed);
			damagePerSecondRange = format("%.1f",damagePerSecondRange);
		end
	end
	local dmgrangeresult;
	dmgrangeresult = rangedAttackBase..":"..rangedAttackMod;
	dmgrangeresult = dmgrangeresult.."||"..displayMin..":"..displayMax..":"..damagePerSecondRange;
	dmgrangeresult = dmgrangeresult.."||"..format("%.2f",rangedAttackSpeed);
	dmgrangeresult = dmgrangeresult.."||"..basePA..":"..posBuffPA;
	dmgrangeresult = dmgrangeresult.."||"..rangecrit;
	JH_Profiler[Plist].newprofil.pf_3 = dmgrangeresult;
	
	-- Profiler : Sortilege
	local spellCrit1 = GetSpellCritChance(2);
	local bonusDamage1 = GetSpellBonusDamage(2);
	local minMod1 = min(spellCrit1,spellCrit1);
	local spellCrit2 = GetSpellCritChance(3);
	local bonusDamage2 = GetSpellBonusDamage(3);
	local minMod2 = min(spellCrit1,bonusDamage2);
	local spellCrit3 = GetSpellCritChance(4);
	local bonusDamage3 = GetSpellBonusDamage(4);
	local minMod3 = min(spellCrit1,bonusDamage3);
	local spellCrit4 = GetSpellCritChance(5);
	local bonusDamage4 = GetSpellBonusDamage(5);
	local minMod4 = min(spellCrit1,bonusDamage4);
	local spellCrit5 = GetSpellCritChance(6);
	local bonusDamage5 = GetSpellBonusDamage(6);
	local minMod5 = min(spellCrit1,bonusDamage5);
	local spellCrit6 = GetSpellCritChance(7);
	local bonusDamage6 = GetSpellBonusDamage(7);
	local minMod6 = min(spellCrit1,bonusDamage6);
	spellCrit1 = format("%.2f",spellCrit1);
	spellCrit2 = format("%.2f",spellCrit2);
	spellCrit3 = format("%.2f",spellCrit3);
	spellCrit4 = format("%.2f",spellCrit4);
	spellCrit5 = format("%.2f",spellCrit5);
	spellCrit6 = format("%.2f",spellCrit6);
	local bonushealing = GetSpellBonusHealing();
	local spellpenetration = GetSpellPenetration();
	local base,casting = GetManaRegen();
	base = floor( (base * 5.0) + 0.5);
	casting = floor( (casting * 5.0) + 0.5);
	local dmgspellresult;
	dmgspellresult = bonusDamage1..":"..bonusDamage2..":"..bonusDamage3..":"..bonusDamage4..":"..bonusDamage5..":"..bonusDamage6;
	dmgspellresult = dmgspellresult.."||"..bonushealing;
	dmgspellresult = dmgspellresult.."||"..spellCrit1..":"..spellCrit2..":"..spellCrit3..":"..spellCrit4..":"..spellCrit5..":"..spellCrit6;
	dmgspellresult = dmgspellresult.."||"..spellpenetration;
	dmgspellresult = dmgspellresult.."||"..base..":"..casting;
	JH_Profiler[Plist].newprofil.pf_4 = dmgspellresult;
	
	-- Profiler : Defenses
	local _, effectiveStat, _, bonus, _ = UnitArmor("player");
	local Parmor = effectiveStat..":"..bonus;
	local base, modifier = UnitDefense("player");
	local Pdefense = base..":"..modifier;
	local Pdodgechance = format("%.2f",(GetDodgeChance()));
	local Pparrychance = format("%.2f",(GetParryChance()));
	local Pblockchance = format("%.2f",(GetBlockChance()));
	JH_Profiler[Plist].newprofil.pf_5 = Parmor.."||"..Pdefense.."||"..Pdodgechance.."||"..Pparrychance.."||"..Pblockchance;

	-- Profiler : Rating
	local result = nil;
	for index, rate in pairs(JHP_Rating) do
		local rating = GetCombatRating(index);
		local ratingBonus = GetCombatRatingBonus(index);
		if result == nil then
			result = rating..":"..ratingBonus;
		else
			result = result.."||"..rating..":"..ratingBonus;
		end
	end
	JH_Profiler[Plist].newprofil.pf_rates = result;
	
	-- Profiler : Skill
	JH_Profiler[Plist].newprofil.pf_skills = {};
	for i=1, GetNumSkillLines(), 1 do
		local _, isHeader = GetSkillLineInfo(i);
		if isHeader then
			ExpandSkillHeader(0);
		end
	end
	local ligne = 1;
	local currentheader = "";
	for i=1, GetNumSkillLines(), 1 do
		local skillName, header, _, skillRank, _, skillModifier, skillMaxRank= GetSkillLineInfo(i);
		if header then
			currentheader = JHC_CleanMe(skillName);
		else
			JH_Profiler[Plist].newprofil.pf_skills["pf_skills_"..i] = currentheader.."||"..JHC_CleanMe(skillName).."||"..skillRank.."||"..skillMaxRank.."||"..skillModifier;
			ligne = ligne+1;
		end
	end

	-- Profiler : factions
	JH_Profiler[Plist].newprofil.pf_factions = {};
	for i=1, GetNumFactions(), 1 do
		local _, _, _, _, _, _, _, _, isHeader= GetFactionInfo(i);
		if isHeader then
			ExpandFactionHeader(0);
		end
	end
	local ligne = 1;
	local currentheader = "";
	for i=1, GetNumFactions(), 1 do
		local name, _, _, bottomValue, topValue, earnedValue, _, _, isHeader = GetFactionInfo(i);
		if isHeader then
			currentheader = JHC_CleanMe(name);
		else
			JH_Profiler[Plist].newprofil.pf_factions["pf_factions_"..i] = currentheader.."||"..JHC_CleanMe(name).."||"..bottomValue.."||"..topValue.."||"..earnedValue;
			ligne = ligne+1;
		end
	end

	-- Profiler : talents
	JH_Profiler[Plist].newprofil.pf_talents = {};
	for i=1, GetNumTalentTabs() do
		local tabname, _, _, background = GetTalentTabInfo(i);
		background = string.gsub(background,"Interface\\Icons\\","");
		local talentstring = nil;
		for t=1, GetNumTalents(i) do
			local _,icone, _, _, currRank, maxRank= GetTalentInfo(i,t);
			if talentstring == nil then
				talentstring = JHC_CleanMe(tabname).."||"..background.."||"..currRank..":"..maxRank;
			else
				talentstring = talentstring.."||"..currRank..":"..maxRank;
			end
		end
		JH_Profiler[Plist].newprofil.pf_talents["pf_talents_"..i] = talentstring;
	end
	
	-- Profiler : objets
	JH_Profiler[Plist].newprofil.pf_stuffs = {};
	for i,stuff in pairs(JHP_Stuff) do
		local link = GetInventoryItemLink("player", i);
		if link then
			if (GetLocale()=="frFR") then
				JHC_ProcessItem(link);
			end
			local texture = GetInventoryItemTexture("player", i);
			texture = string.gsub(texture,"Interface\\Icons\\","");
			for color, id, enchant, sock1, sock2, sock3, sousid in string.gmatch(link, "|c(%x+)|Hitem:(%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):%-?%d+:(%-?%d+):%-?%d+|h%[(.+)%]|h|r") do
				for i=1,JudgeHypeTooltip:NumLines() do
					getglobal("JudgeHypeTooltipTextLeft"..i):SetText("");
					getglobal("JudgeHypeTooltipTextRight"..i):SetText("");
				end
				JudgeHypeTooltip:SetOwner(UIParent, "ANCHOR_NONE");
				JudgeHypeTooltip:SetHyperlink(link);
				local ttip = JHC_GetTooltip();
				JH_Profiler[Plist].newprofil.pf_stuffs["pf_stuffs_"..i] = stuff.."||"..id..":"..sousid..":"..enchant..":"..sock1..":"..sock2..":"..sock3.."||"..color.."||"..texture.."||"..ttip;
			end
		end
	end
	
	-- PvP
	local hk, contribution =  GetPVPLifetimeStats();
	local hc = GetHonorCurrency();
	local ac = GetArenaCurrency();
	JH_Profiler[Plist].newprofil.pf_pvp = hk.."||"..contribution.."||"..hc.."||"..ac;
	
	JHO_ProfilerList();
end
